#include <stdio.h>
#include "kernel/OS.h"

const int32 LOOP_LENGTH = 5000000;
static int32 counter = 0;

long threadFunc(void *);
long threadFunc(void *)
{
   for (int i=0; i<LOOP_LENGTH; i++) atomic_add(&counter, 1);   // no race here, because it's atomic!
}

// This app is just like racecondition.cpp, but it uses Be's atomic_add()
// function to do the adding instead of the regular operations.  Since
// atomic add is... atomic, this should always give the correct result.
int main(int argc, char ** argv)
{
   // Create the separate thread here...
   thread_id launchedThread = spawn_thread(threadFunc, "counter thread", B_NORMAL_PRIORITY, NULL); 
   if (launchedThread >= 0)
   {
      resume_thread(launchedThread);  // gotta do this to start it running

      // Do some counting in this thread too
      threadFunc(NULL);

      status_t threadResult;
      wait_for_thread(launchedThread, &threadResult);

      printf("At the end, counter's value is %lu (should be %lu)\n", counter, LOOP_LENGTH*2);
   }
   else printf("Error launching thread!??!?\n");

   return 0; 
}
